#!/bin/sh

puts "sourcing ../../lan/vlan.tcl..."
source /app/ns-allinone-2.26/ns-2.26/tcl/lan/vlan.tcl
source /app/ns-allinone-2.26/ns-2.26/tcl/lan/ns-mac.tcl


set opt(tr)   xg/_out.tr
#set opt(trTCPOneLine)   xg/_outTCPOneLine.tr
set opt(namtr) "xg/_out.nam"
set opt(seed) 0
#simulate in 20 seconds
set opt(stop) 20
#number of nodes in lan.
set opt(node) 2

set opt(qsize)        100
set opt(bw)   100Mb
set opt(delay)        1ms
set opt(ll)   LL
set opt(ifq)  Queue/DropTail
set opt(mac)  Mac/802_3
set opt(chan) Channel
set opt(tcp)  TCP/Reno
set opt(sink) TCPSink

set opt(app)  FTP

# packet drop rate is 5%
set loss_prob 1

proc finish {} {
    global ns opt qmon qmon2
    puts "\nsrc-node(0)  queuedrop([$qmon set pdrops_]) departure([$qmon set pdepartures_])"
    puts "\nnode(1)-dest queuedrop([$qmon2 set pdrops_]) departure([$qmon2 set pdepartures_])"

    $ns flush-trace

	# get src srtt
	exec grep " t_seqno_ " xg/_out.tr | ./column 0 6 > xg/_SrcSeqno.tr.xgraph
	exec grep " rtt_ " xg/_out.tr | ./column 0 6 > xg/_SrcRtt.tr.xgraph
    exec grep " srtt_ " xg/_out.tr | ./column 0 6 > xg/_SrcSrtt.tr.xgraph
	exec grep " rttvar_ " xg/_out.tr | ./column 0 6 > xg/_SrcRttvar.tr.xgraph
	exec grep " backoff_ " xg/_out.tr | ./column 0 6 > xg/_SrcBackoff.tr.xgraph
    exec grep " cwnd_ " xg/_out.tr | ./column 0 6 >  xg/_SrcCwnd.tr.xgraph
    exec grep " dupacks_ " xg/_out.tr | ./column 0 6 > xg/_SrcDupacks.tr.xgraph
	exec grep " ack_ " xg/_out.tr | ./column 0 6 > xg/_SrcAck.tr.xgraph
	exec grep " ssthresh_ " xg/_out.tr | ./column 0 6 > xg/_SrcSsthresh.tr.xgraph
	exec grep " maxseq_ " xg/_out.tr | ./column 0 6 > xg/_SrcMaxseq.tr.xgraph
	exec grep " ndatapack_ " xg/_out.tr | ./column 0 6 > xg/_SrcNdatapack.tr.xgraph
	exec grep " nrexmit_ " xg/_out.tr | ./column 0 6 > xg/_Nrexmit_.tr.xgraph ;#number of retransmissions
	exec grep " nrexmitpack_ " xg/_out.tr | ./column 0 6 > xg/_Nrexmitpack_.tr.xgraph ;#number of packets retransmiteed.
	exec grep " ncwndcuts_ " xg/_out.tr | ./column 0 6 > xg/_NCWndcuts.tr.xgraph ;#number of times cwnd was reduced for any reason

#    exec grep " saddr " xg/_out.tr | ./column 1 3 > xg/_SrcSaddr.tr.xgraph
#    exec grep " saddr " xg/_out.tr | ./column 1 5 > xg/_SrcSport.tr.xgraph
#    exec grep " saddr " xg/_out.tr | ./column 1 7 > xg/_SrcDaddr.tr.xgraph
#    exec grep " saddr " xg/_out.tr | ./column 1 9 > xg/_SrcDport.tr.xgraph
#    exec grep " saddr " xg/_out.tr | ./column 1 11 > xg/_SrcMaxseq.tr.xgraph
#	exec grep " saddr " xg/_out.tr | ./column 1 13 > xg/_SrcHiack.tr.xgraph
#	exec grep " saddr " xg/_out.tr | ./column 1 15 > xg/_SrcSeqno.tr.xgraph
#	exec grep " saddr " xg/_out.tr | ./column 1 17 > xg/_SrcCwnd.tr.xgraph
#	exec grep " saddr " xg/_out.tr | ./column 1 19 > xg/_SrcSsthresh.tr.xgraph
#	exec grep " saddr " xg/_out.tr | ./column 1 21 > xg/_SrcDupacks.tr.xgraph
#	exec grep " saddr " xg/_out.tr | ./column 1 23 > xg/_SrcRtt.tr.xgraph
#	exec grep " saddr " xg/_out.tr | ./column 1 25 > xg/_SrcSrtt.tr.xgraph
#	exec grep " saddr " xg/_out.tr | ./column 1 27 > xg/_SrcRttvar.tr.xgraph

	exec grep " currto_ " xg/_out.tr | ./column 0 2 > xg/_SrcRto.tr.xgraph
	exec grep " avgcwnd_ " xg/_out.tr | ./column 0 2 > xg/_SrcAvgCwnd.tr.xgraph

    exec grep " q_size " xg/_out.tr | ./column 0 2 > xg/_q_size.tr.xgraph
	exec grep " q_pkts " xg/_out.tr | ./column 0 2 > xg/_q_pkts.tr.xgraph
	exec grep " q2_size " xg/_out.tr | ./column 0 2 > xg/_q2_size.tr.xgraph
	exec grep " q2_pkts " xg/_out.tr | ./column 0 2 > xg/_q2_pkts.tr.xgraph

	exec grep " ackqueuesize_ " xg/_out.tr | ./column 0 2 > xg/_BS_AckQueueSize.tr.xgraph
	exec grep " BSSrtt_ " xg/_out.tr | ./column 0 2 > xg/_BS_Srtt.tr.xgraph    
	exec grep " DropRetransmitedDataPacket " xg/aa | ./column 0 5 > xg/_BS_NumOfRetransPacketDrop.tr.xgraph

      #exec nam $opt(namtr) &

      exit 0
}


proc create-trace {} {
      global ns opt

      if [file exists $opt(tr)] {
              catch "exec rm -f $opt(tr) $opt(tr)-bw [glob $opt(tr).*]"
      }

      set trfd [open $opt(tr) w]
      $ns trace-all $trfd

      if {$opt(namtr) != ""} {
              $ns namtrace-all [open $opt(namtr) w]
      }

      return $trfd
}

#this function should work, but it is NOT tested.
proc create-trace-individual {strOutputFileName} {
      if [file exists $strOutputFileName] {
              catch "exec rm -f $strOutputFileName $strOutputFileName-bw [glob $strOutputFileName.*]"
      }

      set trfd [open $strOutputFileName w]
      return $trfd
}

proc add-error {LossyLink} {

    global loss_prob
    
    # creating the uniform distribution random variable
    set loss_random_variable [new RandomVariable/Uniform] 
    $loss_random_variable set min_ 0    # set the range of the random variable;
    $loss_random_variable set max_ 100
    
    # create the error model;
    set loss_module [new ErrorModel]  
    $loss_module drop-target [new Agent/Null] 
    $loss_module set rate_ $loss_prob  # set error rate to (0.1 = 10 / (100 - 0));
    # error unit: packets (the default);
    $loss_module unit pkt      
    
    # attach random var. to loss module;
    $loss_module ranvar $loss_random_variable 

    # keep a handle to the loss module;
    #set sessionhelper [$ns create-session $n0 $tcp0] 
    $LossyLink errormodule $loss_module
}

proc create-topology {} {
      global ns opt trfd llBS
      global lan node s d linkWireless

      set num $opt(node)
      for {set i 1} {$i < $num} {incr i} {
              set node($i) [$ns node]
              $node($i) color Blue
              $node($i) label "node $i"
              lappend nodelist $node($i)
      }

      set lan [$ns make-lan $nodelist $opt(bw) \
                      $opt(delay) $opt(ll) $opt(ifq) $opt(mac) $opt(chan)]
      
#del      set opt(ll) LL/LLSnoop
      set opt(ifq) Queue/DropTail
      $opt(ifq) set limit_ 100

      # set up snoop agent
      set node(0) [$ns node]
      $node(0) color Blue
      $node(0) add-mark m0 blue box
#      $lan addNode [list $node(0)]  $opt(bw) $opt(delay) $opt(ll) $opt(ifq) $opt(mac)
#      $lan addNode [list $node(0)]  $opt(bw) $opt(delay) LL/LLSnoop $opt(ifq) $opt(mac)
      $lan addNode [list $node(0)]  $opt(bw) $opt(delay) LL/LLWz $opt(ifq) $opt(mac)
      #get LL object
      set nif [$lan set lanIface_($node(0))] ;#get network interface object.
      set llBS [$nif set ll_]
#      $ll set g_ 0.001  ;#0.0625
      $llBS set enableAckControl_ 0
      $llBS set Redefine3DupAck_ 3
      #del $llBS set WirelessDownTime_ 5.0   ;#5.0
      #del $llBS set WirelessDownDuration_ 6.0    ;#6.0
      $node(0) label "n0 <AC [$llBS set enableAckControl_]>"
#del      $ll trace srtt_ $trfd
#    $ll attach $trfd
#    $ll trace ackqueuesize_

      # set source and connect to node(0)
      set s [$ns node]
      $s label "src"
      $s color Green
      $ns duplex-link $s $node(0) 1Mb 5ms DropTail    ;#1Mb 5ms DropTail
      $ns duplex-link-op $s $node(0) orient right-up
      $ns duplex-link-op $s $node(0) label "src to n0"
      $ns queue-limit $s $node(0) 100000
      $ns duplex-link-op $s $node(0) queuePos 0.5

      # set dest and connect to node(1)
      set d [$ns node]
      $d color Green
      lappend nodelistDestLan $d
      DelayLink set delayMode_ 0 ;#0 - constant, 1 - LD_DelayMode_Random
#      DelayLink set WirelessDownTime_ 5.0   ;#5.0
#      DelayLink set WirelessDownDuration_ 6.0    ;#6.0
      $d label "d <delay [DelayLink set delayMode_]>"
      set lanDest [$ns make-lan $nodelistDestLan $opt(bw) \
                      $opt(delay) $opt(ll) $opt(ifq) $opt(mac) $opt(chan)]

      set linkWireless [$ns duplex-link $d $node(1) 250Kb 170ms DropTail]
      $ns duplex-link-op $d $node(1) orient left-down
      $ns duplex-link-op $d $node(1) label "n1 to dest"
      $ns queue-limit $node(1) $d 100000
      $ns duplex-link-op $d $node(1) queuePos 0.5

      set LossyLink [$ns link $node(1) $d]
      add-error $LossyLink
}

proc record {} {
    global ns qmon trfd qmon2 tcp0 totalcwnd node lan
    
    set time 0.01 ;#0.005
    set now [$ns now]
#    puts $qmon instvar size_ pkts_ barrivals_ bdepartures_ parrivals_ pdepartures_ bdrops_ pdrops_
    puts $trfd "$now q_size [$qmon set size_]"
    puts $trfd "$now q_pkts [$qmon set pkts_]"
    puts $trfd "$now q2_size [$qmon2 set size_]"
    puts $trfd "$now q2_pkts [$qmon2 set pkts_]"
    
#    puts $trfd "$now currto_ [$tcp0 set currto_]"  ;# this does NOT work.  currto_ in tcp is always 0.
    puts $trfd "$now currto_ [expr double([$tcp0 set srtt_])/1000 + 4 * double([$tcp0 set rttvar_])/1000]"
    set totalcwnd [expr double([$tcp0 set cwnd_] * $time)]
    puts $trfd "$now avgcwnd_ [expr $totalcwnd/$now]"

    set nif [$lan set lanIface_($node(0))] ;#get network interface object.
    set ll [$nif set ll_]
    puts $trfd "$now ackqueuesize_ [$ll set ackqueuesize_]"
    puts $trfd "$now BSSrtt_ [$ll set srtt_]"    
    
#puts $qbw "$now [expr ($bdepartures_-$old_departure)*8/$time]"
#    set old_departure $bdepartures_

    #if { $now !=0} { puts $qbw "$now [expr $bdepartures_*8/$now]" }

#del    $ns at 2.0 "finish "
    #puts $qlost "$now $pdrops $bdrops_"
    $ns at [expr $now+$time] "record"
}

#delete me, this function is not used.
proc changeDelay0 {} {
    global d node delay1 delay2 delay3 highDelayStart highDelayEnd
    
    set ns [Simulator instance]
    set now [$ns now]
    if ($now<$highDelayStart) then {
        set new_delay [$delay2 value]
    } elseif ($now>$highDelayEnd) then {
        set new_delay [$delay2 value]
        set highDelayStart [expr double($now)+double([$delay1 value])]
        set highDelayEnd [expr $highDelayStart+0.3]
        puts "new high delay period $highDelayStart - $highDelayEnd"
    } else {
        set new_delay [$delay3 value]
    }
    $ns delay $d $node(1) $new_delay duplex ;#duplex ;#simplex
    set time 0.0005 ;#0.0001
    $ns at [expr $now+$time] "changeDelay"
}

#the data in this delay is from K. Luo and A. O. Fapojuwo paper.
proc changeDelay1 {} {
    global d node delayPercent delay1 delay2 delay3 delay4

    set ns [Simulator instance]
    set now [$ns now]

    set whichDelay [$delayPercent value]
    if ($whichDelay<80) then {
        set new_delay [$delay1 value]
    } elseif ($whichDelay<90) then {
        set new_delay [$delay2 value]
    } elseif ($whichDelay<98) then {
        set new_delay [$delay3 value]
    } else {
        set new_delay [$delay4 value]
    }

    $ns delay $d $node(1) $new_delay duplex ;#duplex ;#simplex
    set time 0.0005 ;#0.0001
    $ns at [expr $now+$time] "changeDelay1"
}

#this procedure will set 6 second delay for every 5 seconds
#DOES NOT work, since WirelessDownTime_ and WirelessDownDuration_ in DelayLink cannot be set dynamiclly!
proc changeDelay2 {} {
    global llBS

    set ns [Simulator instance]
    set now [$ns now]
    if ($now>[expr [$llBS set WirelessDownTime_]+[$llBS set WirelessDownDuration_]]) then {
        $llBS set WirelessDownTime_ [expr 5.0+$now]
    }
    set time 0.0005 ;#0.0001
    $ns at [expr $now+$time] "changeDelay2"
}

####################################################################################
## MAIN ##
####################################################################################

set ns [new Simulator]

set trfd [create-trace]
#set trTCPOneLine [create-trace-individual $opt(trTCPOneLine)]

global linkWireless

create-topology

#set tcp0 [$ns create-connection TCP/Reno $s TCPSink $node(1) 0]
#$tcp0 set window_ 30

$ns color 1 Green
#Create a infinite source agent (FTP) tcp and attach it to node n0
#del Agent/TCP set trace_all_oneline_ 1
set tcp0 [new Agent/TCP/Reno]
#del set tcp0 [new Agent/TCP]
$tcp0 set fid_ 1
$tcp0 set backoff_ 2
#default is 20
$tcp0 set window_ 30 ;#initial sshresh
#for what's been traced, see "tcp.cc" for details.  If this is enabled, all other individual trace will be disabled!
#$tcp0 set trace_all_oneline_ 1
$ns attach-agent $s $tcp0

set tcp_snk0 [new Agent/TCPSink]
$ns attach-agent $d $tcp_snk0

$ns connect $tcp0 $tcp_snk0

set ftp0 [$tcp0 attach-app FTP]

# create traces
#del set trAll [open _traceAll.tr w]
$tcp0 attach $trfd
$tcp0 trace t_seqno_
$tcp0 trace rtt_
$tcp0 trace srtt_
$tcp0 trace rttvar_
$tcp0 trace backoff_
$tcp0 trace cwnd_
$tcp0 trace dupacks_
$tcp0 trace ack_
$tcp0 trace ssthresh_
$tcp0 trace maxseq_
$tcp0 trace ndatapack_
$tcp0 trace nrexmit_
$tcp0 trace nrexmitpack_
$tcp0 trace ncwndcuts_

#del puts "maxrto = " [$tcp0 set maxrto_]
#puts "minrto = " [$tcp0 set minrto_]
#$tcp0 trace dupacks_
#$tcp0 trace nrexmitpack_
#$tcp0 trace currto_

set trQueue [open _queue.tr w]
set qmon [$ns monitor-queue $s $node(0) $trQueue]
set qmon2 [$ns monitor-queue $node(1) $d $trQueue]

set delayPercent [new RandomVariable/Uniform]
set delay1 [new RandomVariable/Uniform]
set delay2 [new RandomVariable/Uniform]
set delay3 [new RandomVariable/Uniform]
set delay4 [new RandomVariable/Uniform]
$delayPercent set min_ 0.0
$delayPercent set max_ 100.0
$delay1 set min_ 0.153 ;#0.0
$delay1 set max_ 0.195 ;#100.0
$delay2 set min_ 0.195
$delay2 set max_ 0.225
$delay3 set min_ 0.225
$delay3 set max_ 0.297
$delay3 set min_ 0.297
$delay3 set max_ 0.621
#set dy [new RandomVariable/Exponential]
#$dy set min_ 0.020 ;#10
#$dy set max_ 0.040 ;#20
set highDelayStart 2.0
set highDelayEnd 2.5

# start run simulation
$ns at 0.0 "$ftp0 start"
set totalcwnd 0
$ns at 0.1 "record"

#$llBS set WirelessDownTime_ 5.0   ;#5.0
#$llBS set WirelessDownDuration_ 6.0    ;#6.0
$ns at 0.5 "changeDelay1" ;# vary delay after 1 sec.

#del $ns rtmodel-at 5.0 down $d $node(1)
#$ns rtmodel-at 10.0 up $d $node(1)

$ns at $opt(stop) "finish"

$ns run
